import random
import cocos
import pyglet
import pymunk
from pymunk.vec2d import Vec2d
from math import pi

from pyglet.gl import *

import Actor
import Blob


class Goal(Actor.Actor):
    def __init__(self, context, pos):
        super(Goal, self).__init__(pos)

        self.sprite = cocos.sprite.Sprite("Goal.png")
        self.add(self.sprite)

        self.coll = None
        self.active = False
        self.score = 0
        self.target = 8
        self.intro = False

        self.sprites = []
        for i in range(self.target):
            x = -60 + 30 * (i / 2)
            y = -70 - 20 * (i % 2)
            sprite = cocos.sprite.Sprite("GoalCapturedBlob.png")
            sprite.opacity = 100
            sprite.scale = 0.2
            sprite.x, sprite.y = x, y
            #context.level.add(sprite)
            self.add(sprite)
            self.sprites.append(sprite)

    def update(self, context):
        super(Goal, self).update(context)

        dist, actor = context.level.get_closest_actor_by_type(self.x, self.y, Blob.Blob)
        if dist < 100 and not self.active:
            context.level.removeActor(context, actor)
            if not self.intro and self.score < self.target:
                self.sprites[self.score].opacity = 255
                self.sprites[self.score].scale = 0.3
                self.score += 1


    def load(self, context, data):
        if data == "INTRO":
            self.intro = True

    def load(self, context, data):
        print "iiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiii"
        if data == "INTRO":
            self.intro = True
            print "iiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiii"

    def save(self):
        return "INTRO" if self.intro else "N/A"

