import math
import random
import cocos
import pyglet
import pymunk
from pymunk.vec2d import Vec2d
from math import pi

from pyglet.gl import *

import Actor
import Blob


class Spawner(Actor.Actor):
    def __init__(self, context, pos):
        super(Spawner, self).__init__(pos)

        self.sprite = cocos.sprite.Sprite("Spawner.png")
        self.add(self.sprite)

        self.reload = 2
        self.t = self.reload
        self.ammo = 30
        self.intro = False

        self.sprites = []
        for i in range(self.ammo):
            x = -60 + 30 * (i / 3)
            y = -70 - 20 * (i % 3)
            sprite = cocos.sprite.Sprite("GoalCapturedBlob.png")
            sprite.opacity = 255
            sprite.scale = 0.3
            sprite.x, sprite.y = x, y
            #context.level.add(sprite)
            self.add(sprite)
            self.sprites.append(sprite)

    def update(self, context):
        super(Spawner, self).update(context)

        self.t += context.dt
        if self.t > self.reload and self.ammo > 0:
            self.t -= self.reload
            if not self.intro:
                self.ammo -= 1
                self.sprites[self.ammo].opacity = 50
                self.sprites[self.ammo].scale = 0.2

            actor = context.level.createActor(context, "MoveBlob", self.x, self.y)

            for body, shape in actor.circles:
                spawndir = Vec2d(math.sin(self.rotation * math.pi / 180), math.cos(self.rotation * math.pi / 180))
                body.apply_impulse(spawndir * 3000)



    def load(self, context, data):
        if data == "INTRO":
            self.intro = True

    def save(self):
        return "INTRO" if self.intro else "N/A"