import math
import random
import cocos
import pyglet
import pymunk
from pymunk.vec2d import Vec2d
from math import pi

from pyglet.gl import *

import Actor


class Static(Actor.Actor):
    def __init__(self, context, pos):
        super(Static, self).__init__(pos)

        self.sprites = []

        self.wall = None
        self.set_length(context, 2)

    def set_length(self, context, l):
        self.length = l
        for s in self.sprites:
            self.remove(s)

        self.sprites = []
        for i in range(l):
            s = cocos.sprite.Sprite("box.png")
            s.x = s.width * i
            #s.scale = 0.1
            self.sprites.append( s )
            self.add(s)

        if self.wall is not None:
            context.space.remove(self.wall)

        static_body = pymunk.Body(pymunk.inf, pymunk.inf)
        a = (-16                   , 0)
        b = ( 32 * self.length - 16, 0)
        self.wall = pymunk.Segment(static_body, a, b, 10)
        self.wall.actor = self
        self.wall.body.angle = -self.rotation * math.pi / 180
        self.wall.body.position = self.x, self.y
        context.space.add(self.wall)


    def rotate(self, angle):
        super(Static, self).rotate(angle)
        self.wall.body.angle -= angle *3/180.0
        print self.wall.body.angle

    def move(self, x, y):
        super(Static, self).move(x, y)
        self.wall.body.position = x, y

    def save(self):
        return str(self.length)

    def load(self, context, data):
        self.set_length(context, int(data))



    def destroy(self, context):
        context.space.remove(self.wall)