import cocos
import pymunk

from pyglet.window import key, mouse

import Actor.Blob

class LevelEditorUI( cocos.layer.base_layers.Layer ):
    is_event_handler = True

    def __init__( self, context ):
        super( LevelEditorUI, self ).__init__()
        self.level = context.level
        self.hovered = None

        self.selectionsprite = cocos.sprite.Sprite("editorselection.png")
        self.state = "Selecting"

        # usch
        self.context = context
        self.mousex, self.mousey = (0,0)




    def on_mouse_motion( self, x, y, dx, dy ):
        self.mousex, self.mousey = x,y
        self.deselect()

        dist, actor = self.level.get_closest_actor(x,y)
        if dist < 100:
            self.select(actor)
            self.selectionsprite.x = actor.x
            self.selectionsprite.y = actor.y

    def on_mouse_drag( self, x, y, dx, dy, buttons, modifiers ):
        if self.hovered is None:
            return

        #self.hovered.moveRel(dx, dy)
        if buttons == 1:
            self.hovered.move(x, y)
        if buttons == 4:
            self.hovered.rotate(dx)

    def on_mouse_press( self, x, y, buttons, modifier ):
        #print "lol1",x,y
        #if buttons
        print "level editor"
        if buttons == mouse.LEFT:
            dist, actor = self.level.get_closest_actor_by_type(x,y, Actor.Blob.Blob)
            if dist < 100:
                actor.activate_skill()
        elif buttons == mouse.RIGHT:
            if self.hovered is None:
                self.context.level.createActor(self.context, "Static", x, y)
        elif buttons == mouse.MIDDLE:
            if self.hovered is not None:
                self.context.level.removeActor(self.context, self.hovered)

    def on_mouse_release( self, x, y, button, modifier ):
        return
        self.buttons_new.remove( button )



    def on_key_press( self, k, modifier ):
        print "Keypress: %s Modifers: %s" % ( key.symbol_string(k),  key.modifiers_string(modifier))


        if self.hovered is None:
            if k == key._1:
                self.context.level.createActor(self.context, "Static", self.mousex, self.mousey)
            if k == key._2:
                self.context.level.createActor(self.context, "Sticky", self.mousex, self.mousey)
            if k == key._3:
                self.context.level.createActor(self.context, "Goal", self.mousex, self.mousey)
            if k == key._4:
                self.context.level.createActor(self.context, "Spawner", self.mousex, self.mousey)

        if modifier == 18:#key.LCTRL:
            #print "save", k, key.NUM_1
            if k == key.NUM_1: self.context.level.save( self.context,"level1.txt")
            if k == key.NUM_2: self.context.level.save( self.context,"level2.txt")
            if k == key.NUM_3: self.context.level.save( self.context,"level3.txt")
            if k == key.NUM_4: self.context.level.save( self.context,"level4.txt")
            if k == key.NUM_5: self.context.level.save( self.context,"level5.txt")
            if k == key.NUM_6: self.context.level.save( self.context,"level6.txt")
            if k == key.NUM_7: self.context.level.save( self.context,"level7.txt")
            if k == key.NUM_8: self.context.level.save( self.context,"level8.txt")
        else:
            if k == key.NUM_1: self.context.level.load( self.context,"level1.txt")
            if k == key.NUM_2: self.context.level.load( self.context,"level2.txt")
            if k == key.NUM_3: self.context.level.load( self.context,"level3.txt")
            if k == key.NUM_4: self.context.level.load( self.context,"level4.txt")
            if k == key.NUM_5: self.context.level.load( self.context,"level5.txt")
            if k == key.NUM_6: self.context.level.load( self.context,"level6.txt")
            if k == key.NUM_7: self.context.level.load( self.context,"level7.txt")
            if k == key.NUM_8: self.context.level.load( self.context,"level8.txt")

        if self.hovered == None:
            return
        #for kkk in dir(key): print key
        if k == key.SPACE:
            if isinstance( self.hovered, Actor.Static.Static):
                self.hovered.set_length(self.context, self.hovered.length + 1)



    def select(self, actor):
        self.hovered = actor
        self.hovered.color = (0,1,0)
        self.add(self.selectionsprite)


    def deselect(self):
        if self.hovered is not None:
            self.hovered.color = (1,1,1)
            self.hovered = None
            self.remove(self.selectionsprite)